SoBoxHighlightRenderAction(3)

NAME
SoBoxHighlightRenderAction - The SoBoxHighlightRenderAction class renders the scene with highlighted boxes around selections.

SYNOPSIS

#include <Inventor/actions/SoBoxHighlightRenderAction.h>

Inherits SoGLRenderAction.

  Public Member Functions
virtual SoType getTypeId (void) const
SoBoxHighlightRenderAction (void)
SoBoxHighlightRenderAction (const SbViewportRegion &viewportregion)
virtual ~SoBoxHighlightRenderAction (void)
virtual void apply (SoNode *node)
virtual void apply (SoPath *path)
virtual void apply (const SoPathList &pathlist, SbBool obeysrules=FALSE)
void setVisible (const SbBool visible)
SbBool isVisible (void) const
void setColor (const SbColor &color)
const SbColor & getColor (void)
void setLinePattern (unsigned short pattern)
unsigned short getLinePattern (void) const
void setLineWidth (const float width)
float getLineWidth (void) const

  Static Public Member Functions
static SoType getClassTypeId (void)
static void addMethod (const SoType type, SoActionMethod method)
static void enableElement (const SoType type, const int stackindex)
static void initClass (void)

  Protected Member Functions
virtual const SoEnabledElementsList & getEnabledElements (void) const

  Static Protected Member Functions
static SoEnabledElementsList * getClassEnabledElements (void)
static SoActionMethodList * getClassActionMethods (void)

  Protected Attributes
SbBool hlVisible

  Additional Inherited Members

Detailed Description

The SoBoxHighlightRenderAction class renders the scene with highlighted boxes around selections. This action performs the same tasks as its parent class, SoGLRenderAction, with the added ability to render highlighted bounding boxes around geometry in selected nodes. This is a simple but convenient way of giving feedback to the user upon interaction with the scene graph.

To have the highlighting actually happen (and to be able to automatically 'select' nodes by picking with the mouse cursor), you need to use SoSelection nodes in place of group nodes.

See also
    SoLineHighlightRenderAction, SoSelection

Constructor & Destructor Documentation

  SoBoxHighlightRenderAction::SoBoxHighlightRenderAction (void)
Default constructor. Note: passes a default SbViewportRegion to the parent constructor.

  SoBoxHighlightRenderAction::SoBoxHighlightRenderAction (const SbViewportRegion & viewportregion)
Constructor, taking an explicit viewportregion to render.

  SoBoxHighlightRenderAction::~SoBoxHighlightRenderAction (void) [virtual]
Destructor.

Member Function Documentation

  SoType SoBoxHighlightRenderAction::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoAction. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoGLRenderAction.

  SoType SoBoxHighlightRenderAction::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  void SoBoxHighlightRenderAction::addMethod (const SoType type, SoActionMethod method) [static]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoBoxHighlightRenderAction::enableElement (const SoType type, const int stackindex) [static]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  const SoEnabledElementsList & SoBoxHighlightRenderAction::getEnabledElements (void) const [protected], [virtual]
Returns list of enabled elements.

Reimplemented from SoGLRenderAction.

  SoEnabledElementsList * SoBoxHighlightRenderAction::getClassEnabledElements (void) [static], [protected]
Returns list of enabled elements for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

  SoActionMethodList * SoBoxHighlightRenderAction::getClassActionMethods (void) [static], [protected]
Returns list of action methods for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

  void SoBoxHighlightRenderAction::initClass (void) [static]
Initializes the runtime type system for this class, and sets up the enabled elements and action method list.

  void SoBoxHighlightRenderAction::apply (SoNode * root) [virtual]
Applies the action to the scene graph rooted at root.

Note that you should not apply an action to a node with a zero reference count. The behavior in that case is undefined.

Reimplemented from SoAction.

  void SoBoxHighlightRenderAction::apply (SoPath * path) [virtual]
Applies the action to the parts of the graph defined by path.

Note that an SoPath will also contain all nodes that may influence e.g. geometry nodes in the path. So for instance applying an SoGLRenderAction on an SoPath will render that path as expected in the view, where geometry will get its materials, textures, and other appearance settings correctly.

If the path ends in an SoGroup node, the action will also traverse the tail node's children.

Reimplemented from SoAction.

  void SoBoxHighlightRenderAction::apply (const SoPathList & pathlist, SbBool obeysrules = FALSE) [virtual]
Applies action to the graphs defined by pathlist. If obeysrules is set to TRUE, pathlist must obey the following four conditions (which is the case for path lists returned from search actions for non-group nodes and path lists returned from picking actions):

All paths must start at the same head node. All paths must be sorted in traversal order. The paths must be unique. No path can continue through the end point of another path.

See also
    SoAction::apply(SoPath * path)

Reimplemented from SoAction.

  void SoBoxHighlightRenderAction::setVisible (const SbBool visible)
Sets if highlighted boxes should be visible when rendering. Defaults to TRUE.

  SbBool SoBoxHighlightRenderAction::isVisible (void) const
Returns TRUE if highlighted boxes are visible otherwise FALSE.

  void SoBoxHighlightRenderAction::setColor (const SbColor & color)
Sets the color for the highlighted boxes. Defaults to completely red.

  const SbColor & SoBoxHighlightRenderAction::getColor (void)
Returns the rendering color of the highlighted boxes.

  void SoBoxHighlightRenderAction::setLinePattern (unsigned short pattern)
Sets the line pattern used for the highlighted boxes. Defaults to 0xffff (i.e. drawn with no stipples).

  unsigned short SoBoxHighlightRenderAction::getLinePattern (void) const
Returns the line pattern used when drawing boxes.

  void SoBoxHighlightRenderAction::setLineWidth (const float width)
Sets the line width used when drawing boxes, in screen pixels (as for all OpenGL rendering). Defaults to 3.

  float SoBoxHighlightRenderAction::getLineWidth (void) const
Returns the line width used when drawing highlight boxes.

Member Data Documentation

  SoBoxHighlightRenderAction::hlVisible [protected]
Boolean which decides whether or not the highlights for selected nodes should be visible.

Author

Generated automatically by Doxygen for Coin from the source code.